//#extension GL_EXT_shader_framebuffer_fetch  : require

precision mediump float;    // Should be enough for the Cam Preview TODO not when drawing in buffer ?


varying  vec2      v_Texture_0; // Texture Coordinates Cam
varying  vec2      v_Texture_1; // Texture Coordinates Buffer

uniform  sampler2D Texture_0;   // Y
uniform  sampler2D Texture_1;   // UV
uniform  sampler2D Texture_2;   // Y decoded
uniform  sampler2D Texture_3;   // UV decoded

uniform    float     Fade;
uniform    float     Alpha; // how much the slider says

void main() {
    
    mediump vec3 yuv;
    
    yuv.x   = texture2D(Texture_0, v_Texture_0).r;
    yuv.yz  = texture2D(Texture_1, v_Texture_0).rg - vec2(0.5,0.5) ;
    
    /// ITU_R_601_4 laut screenbuffer
    
    // Using BT.709 which is the standard for HDTV
    vec4 Cam = vec4 ( mat3( 1.0 , 1.0 , 1.0 ,
                           0.0 , -0.344, 1.773,
                           1.403, -0.714, 0.0  ) * yuv , Fade * Alpha);   // 0.4 before need alpha because i grab the screen
    
  /*  mediump vec3 yuvDecoded;
    
    yuvDecoded.x   = texture2D(Texture_2, v_Texture_1).r;
    yuvDecoded.yz  = texture2D(Texture_3, v_Texture_1).rg - vec2(0.5,0.5) ;
    
    /// ITU_R_601_4 laut screenbuffer
    
    // Using BT.709 which is the standard for HDTV
    vec4 Buffer = vec4 (mat3(     1.0,         1.0,           1.0,
                          0.0,         -.18732,       1.8556,
                          1.57481,     -.46813,       0.0      ) * yuvDecoded , 1.0);   // need alpha because i grab the screen
    
    //vec4 Buffer =   texture2D(Texture_2, v_Texture_1);
    vec4 FinalColor = mix( Buffer ,  Cam ,   Fade * 0.3);
    
    gl_FragColor = FinalColor; */
     gl_FragColor = Cam;
    // float wert = colorUV.r;
     //gl_FragColor = vec4( 0.3 , 0.4, 0.3 ,1.0);
    
}
