//#extension GL_EXT_shader_framebuffer_fetch  : require

precision mediump float;    // Should be enough for the Cam Preview TODO not when drawing in buffer ?


varying  vec2      v_Texture_0; // Texture Coordinates

uniform  sampler2D Texture_2;   // Y Decoded
uniform  sampler2D Texture_3;   // UV Decoded
uniform  sampler2D Texture_4;   // Clean Buffer Bottom if Clean Fade to it
uniform  sampler2D Texture_5;   // Clean Buffer Top

uniform  sampler2D Texture_6;   // the CV_MASK :)  1 1 1 0  R = Bottom / G = Top / B = something there
uniform  sampler2D Texture_7;   // last decoded Frame for main Background

uniform  float Fade;  // how much you should fade
uniform  float Fade_2;
void main() {
    

    
   // const float yScale  = 255.0 / (235.0 - 16.0); //(BT709_YMax-BT709_YMin)
  //  const float uvScale = 255.0 / (240.0 - 16.0); //(BT709_UVMax-BT709_UVMin)
   // const float yScale  =  1.164383561643836;
   // const float uvScale =  1.138392857142857;
    
    vec4 Mask_RGBA = texture2D(Texture_6, v_Texture_0); // read all Mask Values / Channel B is now allready Grey Alpha Value for both Channels
    
    // Make one grey value out of the Both Channel mask.
  //  float Mask2 = clamp( dot( Mask_RGBA.rg , vec2(1.0,1.0) ) , 0.0, 1.0) ;  // we need to clamp it because it can be 2.0 at points where to masks had something
    
//    float Mask2 =  texture2D(Texture_6, v_Texture_0).b; // new way. the Mask should have Grey value allready inside on channel B
    
    mediump vec3 yuv;
    // STRECH BECAUSE ITS VIDEO RANGE Y = 16-235 == 219          UV = 16-240 == 224
    yuv.x   = (texture2D(Texture_2, v_Texture_0).r - 0.062745098039216) * 1.164383561643836;
    yuv.yz  = vec2( texture2D(Texture_3, v_Texture_0).rg - vec2(0.5,0.5) )*  1.138392857142857 ;
    
    /// ITU_R_601_4 laut screenbuffer
    // Using BT.709 which is the standard for HDTV
    vec4 Decoded = vec4 (      mat3(     1.0,      1.0,        1.0,
                                    0.0,      -.18732,    1.8556,
                                    1.57481,  -.46813,    0.0      ) * yuv , 1.0);   // need alpha because i grab the screen
    
   // yuv.x   = (texture2D(Texture_2, v_Texture_0).r - 0.062745098039216) * 1.164383561643836;
    
    
    /// MASK

  
    // TODOO couldnt i write a grey value in third channel ????
    

    // Set how much the bottom Layer should overwrite with clean
    vec4 Input = mix( Decoded, texture2D(Texture_4, v_Texture_0), Fade * Mask_RGBA.r);
    
    // And now add the Top Layer fade if needed
    Input = mix( Input, texture2D(Texture_5, v_Texture_0), Fade_2 * Mask_RGBA.g);
  
    // Draw the last Decoded Frame TEX_7 as Background and the new Input on Top
    gl_FragColor  = mix(  texture2D(Texture_7, v_Texture_0), Input, Mask_RGBA.b);
    //gl_FragColor = texture2D(Texture_6, v_Texture_0);
    
    // gl_FragColor =  vec4( 0.0 ,  0.2 , 0.4 , 1.0);
    
   // gl_FragColor = vec4(  yuv.x,  yuv.x ,  yuv.x , 1.0);
    
    // Using BT.709 which is the standard for HDTV
   
    
    // float wert = colorUV.r;
    // gl_FragColor = vec4(wert,wert,wert.1,0);
    
}
