//#extension GL_EXT_shader_framebuffer_fetch  : require

precision highp float;    // Should be enough for the Cam Preview TODO not when drawing in buffer ?


//varying  vec2      v_Texture_0; // Texture Coordinates
varying    vec2 v_Mask[9];  //  Mask positions the Center is inside

uniform  sampler2D Texture_2;   // Y Decoded
uniform  sampler2D Texture_3;   // UV

uniform  float      Alpha; 

void main() {
    
    mediump vec3 YUV;      // the normal decoded frame
    mediump vec3 YUV_K;    // with kontrast
    
    highp float  blur  =  texture2D(Texture_2, v_Mask[0]   ).r  * 0.077847;  // 0  !!!
    blur +=  texture2D(Texture_2, v_Mask[1]   ).r  * 0.123317;  // 1
    blur +=  texture2D(Texture_2, v_Mask[2]   ).r  * 0.077847;  // 2
    blur +=  texture2D(Texture_2, v_Mask[3]   ).r  * 0.123317;  // 3
    blur +=  texture2D(Texture_2, v_Mask[4]  ).r  * 0.195346;  //   MITTE
    blur +=  texture2D(Texture_2, v_Mask[5]   ).r  * 0.123317;  // 4
    blur +=  texture2D(Texture_2, v_Mask[6]   ).r  * 0.077847;  // 5
    blur +=  texture2D(Texture_2, v_Mask[7]   ).r  * 0.123317;  // 6
    blur +=  texture2D(Texture_2, v_Mask[8]   ).r  * 0.077847;  // 7
    
    
    // STRECH BECAUSE ITS VIDEO RANGE Y = 16-235 == 219          UV = 16-240 == 224
    YUV.x  = (blur - 0.062745098039216) * 1.164383561643836; //  (texture2D(Texture_2,  v_Mask[4] ).r
    YUV.x  = clamp(YUV.x,0.0,1.0); // to be save
    YUV.yz = vec2( texture2D(Texture_3,  v_Mask[4] ).rg  - vec2(0.5,0.5) ) * 1.138392857142857 ;
    
    /// Removes Colors
    float Desaturate = 1.0 - ( Alpha * 2.6 ); // starts at 1.0
    Desaturate       = clamp( Desaturate , 0.0 , 1.0);
 
    YUV_K.yz = YUV.yz * Desaturate; // reduce Color
    
    /// KONTRAST
  //  float KONTRAST = Alpha * 0.4;
 //   KONTRAST = clamp ( KONTRAST , 0.0, 0.1);
    
    //float Light = YUV.x - 0.5;
  //  Light       = Light * (1.0 ); //+ KONTRAST ) ; //+ Alpha);
    //Light       = Light + 0.5;
    
   // float Light = smoothstep( KONTRAST , 1.0 - KONTRAST , YUV.x );
    
    float POW = 1.0 + ( 4.0 * Alpha ); // 4.0 defines the speed POW is raised
    POW = clamp ( POW , 0.0, 2.6);   // clamp it to some limit
    
    float Darker = Alpha * 0.8 ; // set how fast you darken
    Darker = clamp ( Darker , 0.0, 0.65); // dont darken till 0.0
    
    float Light   = pow(YUV.x, POW);
    YUV_K.x = clamp ( Light  * ( 1.0 - Darker) , 0.0 , 1.0);
    // REDUCE BRIGHT
    
  
   // Darker = 0.0;
    
   // YUV_K.x = Light * ( 1.0 - Darker);
     //  = Light;
    
  //  YUV_K = YUV;
    // MAKE Dark brighter
   // yuv.x = yuv.x + ( Alpha * 0.3 );
  //  yuv.x = clamp( yuv.x  , 0.0 , 1.0);
    /// ITU_R_601_4 laut screenbuffer
    
    // Using BT.709 which is the standard for HDTV
    vec4 GLITCH = vec4 (       mat3(     1.0,      1.0,        1.0,
                                    0.0,      -.18732,    1.8556,
                                    1.57481,  -.46813,    0.0      )  * YUV , 1.0);   // need alpha because i grab the screen
    
    vec4 GLITCH_K = vec4 (       mat3(     1.0,      1.0,        1.0,
                                      0.0,      -.18732,    1.8556,
                                      1.57481,  -.46813,    0.0      )  * YUV_K , 1.0);
    
    
    float Grey = dot( GLITCH , vec4( 0.2126 , 0.7152 , 0.0722 , 0.0 ) ); // Normal Grey
    
   // vec4 Black = vec4 ( 0.0 , 0.0 , 0.0 , 1.0);
    
   // float MakeBlack = Alpha * 2.0;
   // MakeBlack = clamp( MakeBlack , 0.0 , 0.75);
    
    //gl_FragColor =  mix (   CAM ,  Black , MakeBlack  );
    
    gl_FragColor = GLITCH_K;
    gl_FragColor.a = pow(Grey , 0.8); // store grey value for the logo in next draw call // a bit reduced ?
    
    
   // gl_FragColor = vec4(  YUV.x,YUV.x,YUV.x , 1.0);
  //  gl_FragColor = GLITCH;
    // BT.601, which is the standard for SDTV is provided as a reference
    /*
     rgb = mat3(      1,       1,       1,
     0, -.39465, 2.03211,
     1.13983, -.58060,       0) * yuv;
     */
    
    // Using BT.709 which is the standard for HDTV
    
    
    // float wert = colorUV.r;
    // gl_FragColor = vec4(wert,wert,wert.1,0);
    
}
