#extension GL_EXT_shader_framebuffer_fetch  : require

precision mediump float;    // Should be enough for the Cam Preview TODO not when drawing in buffer ?


varying  vec2      v_Texture_0; // Texture Coordinates

//uniform  sampler2D Texture_4;   // Y
//uniform  sampler2D Texture_1;   // UV


uniform  sampler2D Texture_0;   // Y or RGB when you have text
uniform  sampler2D Texture_1;   // UV

uniform  float    Alpha;
uniform  int      Mode;
uniform  int   Inverted;

void main() {
    
    vec4 Input;
    
    vec4 Background = gl_LastFragData[0];
    
    if( Mode == 1 ) {
        
        Input = texture2D(Texture_0, v_Texture_0);
       // Background = mix( 1.0 - Background, Background, Input.a); // so you can see black font
      //  Inverted = 1.0 - Inverted;
        
    } else {
        mediump vec3 yuv;
        yuv.x  = (texture2D(Texture_0, v_Texture_0).r - 0.062745098039216) * 1.164383561643836;
        yuv.yz = vec2( texture2D(Texture_1, v_Texture_0).rg - vec2(0.5,0.5) ) * 1.138392857142857 ;
      
        
        Input  = vec4 ( mat3(     1.0,      1.0,       1.0,
                                  0.0,  -.18732,    1.8556,
                              1.57481,  -.46813,       0.0   ) * yuv , 1.0);
    }
  

   // vec4 Input   = texture2D(Texture_4, v_Texture_0);
                    
   // vec4 MIX = mix( Decoded,  Input  ,  0.5);
   // vec4 Difference =    Input - Decoded + 0.5;
    if( Inverted == 1) { // because we want it different if there is some inverted color mode
        Background = 1.0 - Background;
    }
    vec4 Difference =  abs( Input - Background ) * 2.0;
    float grey      = dot(Difference , vec4(0.2126, 0.7152, 0.0722, 0.0 ) );
    gl_FragColor    =  vec4( grey,grey,grey, Input.a * Alpha); //MIX;   // need alpha because i grab the screen
    
   // gl_FragColor  = Input;
  //  gl_FragColor = texture2D(Texture_0, v_Texture_0);
  //  gl_FragColor.a = 1.0;
}
