//#extension GL_EXT_shader_framebuffer_fetch  : require

precision mediump float;    // Should be enough for the Cam Preview TODO not when drawing in buffer ?




uniform  sampler2D Texture_0;   // RGB
uniform  sampler2D Texture_4;   // Background

varying  vec2      v_Texture_0; // Texture Coordinates
varying  vec4       v_Texture_Project;  // for the background texture
//uniform  sampler2D Texture_1;   // UV

uniform  int      Mode;
uniform  int      Inverted;   // for mixing image with cam we want to try to invert all on the first frame
uniform  float    Alpha;
uniform  float    Fade;
/// FOR NOISE
/// https://www.kodeco.com/2323-opengl-es-pixel-shaders-tutorial

float randomNoise(vec2 p) {
 // return fract(6791.*sin(47.*p.x+p.y*9973.));
   return fract( 1000. * sin( 16.0 * ( p.x + p.y ) ) );
}

void main() {
    
    

    
    
    vec4 finalColor = texture2D(Texture_0, v_Texture_0);    // Used if Color Mode
    float grey      = dot(finalColor , vec4(0.2126, 0.7152, 0.0722, 0.0 ) );
    float RealAlpha = finalColor.a; // keep for later
    
    if( Mode == 1 ) {   // BW
        
        finalColor = vec4(grey, grey, grey, 1.0);
        
    } else if( Mode == 2 ) {    // BW_INVERT
        
        grey = 1.0 - grey;
        finalColor = vec4(grey, grey, grey, 1.0);
        
    } else if( Mode == 3 ) {    // COLOR INVERT
        
        vec4 yuva = vec4(0.0);
        vec4 rgba = finalColor;
        
        yuva.x = rgba.r *  0.299 + rgba.g *  0.587 + rgba.b *  0.114;
        yuva.y = rgba.r * -0.169 + rgba.g * -0.331 + rgba.b *  0.5;
        yuva.z = rgba.r *  0.5   + rgba.g * -0.419 + rgba.b * -0.081;
        yuva.w = 1.0;
        
        yuva.x = 1.0 -  yuva.x ;
        
        finalColor = vec4 (      mat3( 1.0   , 1.0    , 1.0   ,
                                      0.0   , -0.344 , 1.773 ,
                                      1.403 , -0.714 , 0.0     ) * yuva.rgb , 1.0);
    }
    
  
    // invert on first frane when buffer image
    if( Inverted != 0) {
        finalColor = vec4(1.0,1.0,1.0,1.0) - finalColor;
        finalColor = clamp(finalColor , vec4(0.0), vec4(1.0) );
        
     
     //   vec2 position = gl_FragCoord.xy /  vec2(400.0,400.0);
      //  float n = randomNoise(position);
      //  finalColor = vec4(vec3(n), 1.);
       
            
       // gl_FragColor = vec4( 1.0 , 0.1 , 0.1, 1.0);
    } else {
       // gl_FragColor = vec4( 0.0 , 1.0 , 0.1, 1.0);
    }
    
    finalColor.a = RealAlpha * Alpha;
    
  /*  if( Fade > 0.5) {
        vec2 finalTextureVec = v_Texture_Project.xy / v_Texture_Project.w;
        finalTextureVec = vec2 ( finalTextureVec.x * 0.5 + 0.5, finalTextureVec.y * 0.5 + 0.5); // no flip because we want it upside down ?? seems so
      vec4 Background = texture2D(Texture_4, finalTextureVec);
        
        finalColor = mix( Background, finalColor, RealAlpha );
        
        finalColor.a = 1.0;
    } */
  
    gl_FragColor = finalColor;
   // gl_FragColor = finalColor;
    //  gl_FragColor = vec4( 0.4 , 0.3 , 0.4 , 1.0);
    
}
