
//  Blur Mask

precision highp float;

attribute  vec4     a_Vertex;       // Points
attribute  vec4     a_Texture_0;    // Oben


varying    vec2  v_Mask[9];  //  Mask positions the Center is inside
uniform    float Width;
uniform    float Height;

///     0   1   2
///     3   4   5
///     6   7   8

///            0
///       1    2    3
///  4    5    6    7    8
///       9   10   11
///           12

void main() {
    
    gl_Position         = a_Vertex;
    
    vec2 Center         = a_Texture_0.xy;

    
    float step_X   = 1.0 / Width; // pre calc??? TODO same for height just in this case
    float step_Y   = 1.0 / Height;
    // float step_2       = step_1 * 2.0;
    
    // 0 1 2
    // 3 4 5
    // 6 7 8
    
    v_Mask[ 0] = Center + vec2( -step_X ,  step_Y );
    v_Mask[ 1] = Center + vec2(  0.0    ,  step_Y );
    v_Mask[ 2] = Center + vec2(  step_X ,  step_Y );
    v_Mask[ 3] = Center + vec2( -step_X ,  0.0    );
    v_Mask[ 4] = Center;
    v_Mask[ 5] = Center + vec2(  step_X ,  0.0    );
    v_Mask[ 6] = Center + vec2( -step_X , -step_Y );
    v_Mask[ 7] = Center + vec2(  0.0    , -step_Y );
    v_Mask[ 8] = Center + vec2(  step_X , -step_Y );
    
    
  /*  v_Blur[ 0]  = Mitte + vec2(  0.0    ,  wert2);
    v_Blur[ 1]  = Mitte + vec2( -wert   ,   wert);
    v_Blur[ 2]  = Mitte + vec2(  0.0    ,   wert);
    v_Blur[ 3]  = Mitte + vec2(  wert   ,   wert);
    v_Blur[ 4]  = Mitte + vec2( -wert2  ,    0.0);
    v_Blur[ 5]  = Mitte + vec2( -wert   ,    0.0);
    
    v_Blur[ 6]  = Mitte;
    
    v_Blur[ 7]  = Mitte + vec2(  wert   ,    0.0);
    v_Blur[ 8]  = Mitte + vec2(  wert2  ,    0.0);
    v_Blur[ 9]  = Mitte + vec2( -wert   ,  -wert);
    v_Blur[ 10] = Mitte + vec2(  0.0    ,  -wert);
    v_Blur[ 11] = Mitte + vec2(  wert   ,  -wert);
    v_Blur[ 12] = Mitte + vec2(  0.0    , -wert2); */


}
